<script lang="ts" setup>
import { usePromotionStore } from '@/stores/Promotion'
import { computed, onMounted, ref, watch } from 'vue'

const promotionStore = usePromotionStore()
const selectedDate = ref()
const showDatePicker = ref(false)

if (promotionStore.editedPromotion.id! > -1) {
  selectedDate.value = parseDateDMY(promotionStore.editedPromotion.startdate)
}
// แปลงคืน
function parseDateDMY(dateString: any) {
  const parts = dateString.split('-')
  const day = parseInt(parts[0], 10)
  const month = parseInt(parts[1], 10) - 1 // Months are zero-based in JavaScript
  const year = parseInt(parts[2], 10) + 2000 // Assuming the year is 2-digit representation

  return new Date(year, month, day)
}
// แปลง Date เป็น String
const formattedDate = computed(() => {
  if (!selectedDate.value) return null
  const date = new Date(selectedDate.value)
  const year = date.getFullYear()
  const month = (date.getMonth() + 1).toString().padStart(2, '0')
  const day = date.getDate().toString().padStart(2, '0')

  return `${day}-${month}-${year}`
})

watch(formattedDate, (newValue) => {
  if (newValue !== null) {
    promotionStore.editedPromotion.startdate = newValue
  }
})

const updateSelectedDate = (newValue: any) => {
  selectedDate.value = newValue
}
const toggleDatePicker = () => {
  showDatePicker.value = !showDatePicker.value
}
</script>
<template>
  <v-text-field
    v-model="formattedDate"
    :readonly="true"
    :rules="[(v) => !!v || 'Field is required']"
    append-inner-icon="mdi-calendar"
    @click="toggleDatePicker"
    label="Select Date"
  ></v-text-field>
  <v-date-picker
    class="small-datepicker"
    v-model="selectedDate"
    @input="updateSelectedDate"
    format="yyyy-MM-dd"
    color="#784424"
    v-show="showDatePicker"
  />
</template>
<style scoped>
.small-datepicker .v-date-picker-header,
.small-datepicker .v-date-picker-title {
  font-size: 12px; /* Adjust the font size as needed */
}

.small-datepicker .v-date-picker-table {
  margin: 0; /* Adjust the margin as needed */
}

.small-datepicker .v-btn {
  padding: 4px 8px; /* Adjust the padding as needed */
}
</style>
